/* Strip whitespace from the beginning and end of a string */
if (typeof String.prototype.trim == "undefined") {
    String.prototype.trim = function () {
        var s = this.replace(/^\s*/, "");
        return s.replace(/\s*$/, "");
    }
}

if (typeof String.prototype.initCaps == "undefined") {
    String.prototype.initCaps = function () {
        return this.substring(0,1).toUpperCase()+ this.substring(1,this.length);
    }
}

var adprf = new Array();
adprf["extensions.adhiyan.englishshortcut"] = "Alt+1";
adprf["extensions.adhiyan.tsciishortcut"] = "Alt+2";
adprf["extensions.adhiyan.tuneshortcut"] = "Alt+3";
adprf["extensions.adhiyan.ascshortcut"] = "Alt+4";
adprf["extensions.adhiyan.tabshortcut"] = "Alt+5";
adprf["extensions.adhiyan.tamshortcut"] = "Alt+6";
adprf["extensions.adhiyan.thanthishortcut"] = "Alt+7";
adprf["extensions.adhiyan.manishortcut"] = "Alt+8";

function adhiyan_populateURLList()
{
	if(navigator.userAgent.indexOf("Thunderbird") >= 0)
	{
		document.getElementById("selurlgrp").hidden = true;
		return;
	}
	var adPrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(
					Components.interfaces.nsIPrefService).getBranch("extensions.adhiyan.");
	var urllist = adPrefs.getCharPref("selecturls").split(";");
	if(urllist[0] == "") return;
	selectlist = document.getElementById("selectlist");
	for(i=0;i<urllist.length;i++)
	{
		listitem = document.createElement("listitem");
		listcellURL = document.createElement("listcell");
		listcellKbrd = document.createElement("listcell");
		convlist = document.getElementById("selectconvr").childNodes[0].childNodes;
		convvalue = urllist[i].split(",")[1];
		convlabel = convlist[ urllist[i].split(",")[1] ].label;
		listcellURL.setAttribute("label", urllist[i].split(",")[0]);
		listcellKbrd.setAttribute("label",convlabel);
		listcellKbrd.setAttribute("value",convvalue);
		listitem.appendChild(listcellURL);
		listitem.appendChild(listcellKbrd);
		selectlist.appendChild(listitem);
	}
}

function adhiyan_setDefaultConvMaps()
{
	var adhiyan_appcontent = document.getElementById("appcontent"); //browser
	var adhiyan_messagepane = document.getElementById("messagepane");   //mail
	if(navigator.userAgent.indexOf("Thunderbird") >= 0)
	{
		if(adhiyan_messagepane)
			adhiyan_messagepane.addEventListener("DOMContentLoaded",adhiyan_AutoConv,false);
		return;
	}
	var adPrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(
					Components.interfaces.nsIPrefService).getBranch("extensions.adhiyan.");
	var urllist = adPrefs.getCharPref("selecturls").split(";");
	if(urllist[0] == "")
	{
		if(adhiyan_appcontent)
			adhiyan_appcontent.addEventListener("DOMContentLoaded",adhiyan_AutoConv,false);
		if(adhiyan_messagepane)
			adhiyan_messagepane.addEventListener("DOMContentLoaded",adhiyan_AutoConv,false);
		return;
	}
	var retArr = new Array();
	myConvArr = new Array("tscii","tune","asc","tab","tam","thanthi","mani","english");
	for(i=0;i<urllist.length;i++)
		if(content.location.href.indexOf(urllist[i].split(",")[0]) >= 0 )
		{
			var selconv = myConvArr[ urllist[i].split(",")[1] ]
			adPrefs.setBoolPref("showcn"+selconv, true);
			adhiyan_setEnc(selconv);
		}
	if(adhiyan_appcontent)
		adhiyan_appcontent.addEventListener("DOMContentLoaded",adhiyan_AutoConv,false);
	if(adhiyan_messagepane)
		adhiyan_messagepane.addEventListener("DOMContentLoaded",adhiyan_AutoConv,false);
}

function adhiyan_AutoConv(evt)
{
	oldloc = "";
	adhiyan_setMenus(adhiyan_selEnc)
	adhiyan_convWin();
}

function adhiyan_saveURLList()
{
	var adPrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(
					Components.interfaces.nsIPrefService).getBranch("extensions.adhiyan.");
	selectlist = document.getElementById("selectlist");
	var prefString = "";

	for (var i=2; i < selectlist.childNodes.length; i++)
	{
		var columns = selectlist.childNodes[i].childNodes;
		var str = columns[0].getAttribute("label") + ","
		    + columns[1].getAttribute("value");
		if(prefString == "")
			prefString = str;
		else
			prefString += ";" + str;
	}
	var str = Components.classes["@mozilla.org/supports-string;1"]
      .createInstance(Components.interfaces.nsISupportsString);
	adPrefs.setCharPref("selecturls",prefString)
	selectlist.setAttribute("adhiyan.attribute.modified","no");
}


function adhiyan_unloadAlert()
{
	if(tuneshortcut.keyData.modified || tsciishortcut.keyData.modified ||
		englishshortcut.keyData.modified || ascshortcut.keyData.modified ||
		tabshortcut.keyData.modified || tamshortcut.keyData.modified ||
		thanthishortcut.keyData.modified || manishortcut.keyData.modified )
		alert('\u0BA4\u0BC6\u0BB0\u0BBF\u0BB5\u0BC1\u0B95\u0BB3\u0BC8 '
				+'\u0BAE\u0BBE\u0BB1\u0BCD\u0BB1\u0BBF\u0BAF \u0BAA\u0BBF\u0BA9\u0BCD '
				+'\u0B9A\u0BC6\u0BAF\u0BB2\u0BBF\u0BAF\u0BC8 \u0BAE\u0BC2\u0B9F\u0BBF '
				+'\u0BAE\u0BB1\u0BC1\u0BA4\u0BC1\u0BB5\u0B95\u0BCD\u0B95\u0BAE\u0BCD '
				+'\u0B9A\u0BC6\u0BAF\u0BCD\u0BAF\u0BB5\u0BC1\u0BAE\u0BCD.');
	if(selectlist != null && selectlist.getAttribute("adhiyan.attribute.modified") == "yes")
			adhiyan_saveURLList();
}

function adhiyan_addURL(aNode)
{

	selectconvr = document.getElementById('selectconvr');
	selecturl = document.getElementById('selecturl');
	if(adhiyan_ValidateURL(selecturl))
	{
		listitem = document.createElement("listitem");
		listcellURL = document.createElement("listcell");
		listcellKbrd = document.createElement("listcell");
		listcellURL.setAttribute("label", selecturl.value.trim());
		listcellKbrd.setAttribute("label",selectconvr.label);
		listcellKbrd.setAttribute("value",selectconvr.value);
		listitem.appendChild(listcellURL);
		listitem.appendChild(listcellKbrd);
		aNode.appendChild(listitem);
		selecturl.value = "";
		selecturl.focus();
		selectlist.setAttribute("adhiyan.attribute.modified","yes");
		aNode.selectedIndex = -1;
	}
	else
		alert("\u0B9A\u0BC1\u0B9F\u0BCD\u0B9F\u0BBF \u0B9A\u0BC6\u0BB2\u0BCD\u0BB2\u0BBE\u0BA4\u0BC1");
}

function adhiyan_delURL(aNode)
{
	if(aNode.selectedIndex < 0)
		alert("\u0BA8\u0BC0\u0B95\u0BCD\u0B95 \u0BB5\u0BC7\u0BA3\u0BCD\u0B9F\u0BBF\u0BAF \u0B9A\u0BC1\u0B9F\u0BCD\u0B9F\u0BBF\u0BAF\u0BC8 \u0BA4\u0BC7\u0BB0\u0BCD\u0BA8\u0BCD\u0BA4\u0BC6\u0B9F\u0BC1\u0B95\u0BCD\u0B95\u0BB5\u0BC1\u0BAE\u0BCD.")
	else
	{
		aNode.removeItemAt(aNode.selectedIndex);
		selectlist.setAttribute("adhiyan.attribute.modified","yes");
		selecturl = document.getElementById('selecturl');
		selecturl.value = "";
		selecturl.focus();
	}
}

function adhiyan_edtURL(aNode)
{
	if(aNode.selectedIndex == -1) return;
	selectconvr = document.getElementById('selectconvr');
	selecturl = document.getElementById('selecturl');
	selecturl.value = aNode.getItemAtIndex(aNode.selectedIndex).firstChild.getAttribute("label");
	selectconvr.setAttribute("label",aNode.getItemAtIndex(aNode.selectedIndex).lastChild.getAttribute("label"))
}

function adhiyan_ValidateURL(surl)
{
	if(surl.value.trim() == "" || surl.value.trim().indexOf(".") == -1)
		return false;
	else
		return true;
}

function adhiyan_setAccessKeys()
{
	var adPrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(
					Components.interfaces.nsIPrefService).getBranch("extensions.adhiyan.");
	adhiyan_setAccKey("english",adPrefs);
	adhiyan_setAccKey("tune",adPrefs);
	adhiyan_setAccKey("tscii",adPrefs);
	adhiyan_setAccKey("asc",adPrefs);
	adhiyan_setAccKey("tab",adPrefs);
	adhiyan_setAccKey("tam",adPrefs);
	adhiyan_setAccKey("thanthi",adPrefs);
	adhiyan_setAccKey("mani",adPrefs);
	var menu = document.getElementById("contentAreaContextMenu");
	var menu_tl = document.getElementById("menu_ToolsPopup");
	var tbmenu1 =  document.getElementById("msgComposeContext");
	var tbmenu2 =  document.getElementById("messagePaneContext");
	if(menu != null)
  		menu.addEventListener("popupshowing", adhiyan_contextPopupShowing, false);
	if(menu_tl != null)
  		menu_tl.addEventListener("popupshowing", adhiyan_contextPopupShowing, false);
	if(tbmenu1 != null)
  		tbmenu1.addEventListener("popupshowing", adhiyan_contextPopupShowing, false);
	if(tbmenu2 != null)
  		tbmenu2.addEventListener("popupshowing", adhiyan_contextPopupShowing, false);
}

function adhiyan_contextPopupShowing(evt)
{
	var adPrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(
				Components.interfaces.nsIPrefService).getBranch("extensions.adhiyan.");
	var menu = document.getElementById("adhiyanmnu");
	var rcxt =  document.getElementById("adhiyancxt");
	if(menu != null)
	{
		var englishmnu = document.getElementById("englishmnu");
		englishmnu.hidden = !adPrefs.getBoolPref("showcnenglish");
		var tsciimnu   = document.getElementById("tsciimnu");
		tsciimnu.hidden = !adPrefs.getBoolPref("showcntscii");
		var tunemnu    = document.getElementById("tunemnu");
		tunemnu.hidden = !adPrefs.getBoolPref("showcntune");
		var ascmnu     = document.getElementById("ascmnu");
		ascmnu.hidden = !adPrefs.getBoolPref("showcnasc");
		var tabmnu     = document.getElementById("tabmnu");
		tabmnu.hidden = !adPrefs.getBoolPref("showcntab");
		var tammnu     = document.getElementById("tammnu");
		tammnu.hidden = !adPrefs.getBoolPref("showcntam");
		var thanthimnu = document.getElementById("thanthimnu");
		thanthimnu.hidden = !adPrefs.getBoolPref("showcnthanthi");
		var manimnu    = document.getElementById("manimnu");
		manimnu.hidden = !adPrefs.getBoolPref("showcnmani");
	}
	if(rcxt != null)
	{
		var englishcxt = document.getElementById("englishcxt");
		englishcxt.hidden = !adPrefs.getBoolPref("showcnenglish");
		var tsciicxt   = document.getElementById("tsciicxt");
		tsciicxt.hidden = !adPrefs.getBoolPref("showcntscii");
		var tunecxt    = document.getElementById("tunecxt");
		tunecxt.hidden = !adPrefs.getBoolPref("showcntune");
		var asccxt     = document.getElementById("asccxt");
		asccxt.hidden = !adPrefs.getBoolPref("showcnasc");
		var tabcxt     = document.getElementById("tabcxt");
		tabcxt.hidden = !adPrefs.getBoolPref("showcntab");
		var tamcxt     = document.getElementById("tamcxt");
		tamcxt.hidden = !adPrefs.getBoolPref("showcntam");
		var thanthicxt = document.getElementById("thanthicxt");
		thanthicxt.hidden = !adPrefs.getBoolPref("showcnthanthi");
		var manicxt    = document.getElementById("manicxt");
		manicxt.hidden = !adPrefs.getBoolPref("showcnmani");
	}
}

function adhiyan_setAccKey(kbrd,adPrefs)
{
	if(adPrefs.prefHasUserValue(kbrd+"shortcut"))
	{
		var ukey = document.getElementById(kbrd+"key");
		var keypref = adhiyan_parseShortcut(adPrefs.getCharPref(kbrd+"shortcut"));
		var keycode = keypref.keyCode;
		var key = keypref.key;
		var modifiers = [];
		if(keypref.altKey) modifiers.push("alt");
		if(keypref.ctrlKey) modifiers.push("control");
		if(keypref.metaKey) modifiers.push("meta");
		if(keypref.shiftKey) modifiers.push("shift");
		modifiers = modifiers.join(" ");
		ukey.removeAttribute('key');
		ukey.removeAttribute('keycode');
		ukey.removeAttribute('modifiers');
		if(key != '') ukey.setAttribute('key', key);
		if(keycode != '') ukey.setAttribute('keycode', keycode);
		ukey.setAttribute('modifiers', modifiers);
	}
}

function adhiyan_setShortcut(aNode)
{
		window.openDialog(
			'chrome://adhiyan/content/keyDetecter.xul',
			'_blank',
			'chrome,modal,resizable=no,titlebar=no,centerscreen',
			aNode.keyData,
			document.getElementById('dialogMessage').getAttribute('dialogMessage'),
			document.getElementById('dialogMessage').getAttribute('dialogButton')
		);
		if (aNode.keyData.modified) {
			aNode.value = aNode.keyData.string;
			var event = document.createEvent('UIEvents');
			event.initUIEvent('input', true, false, window, 0);
			aNode.dispatchEvent(event);
		}
}
function adhiyan_clearShortcut(aNode)
{
	aNode.value = adprf["extensions.adhiyan."+aNode.id];
	aNode.keyData = adhiyan_parseShortcut(aNode.value);
	aNode.keyData.modified = true;

	var event = document.createEvent('UIEvents');
	event.initUIEvent('input', true, false, window, 0);
	aNode.dispatchEvent(event);
}

function adhiyan_parseShortcut(aShortcut)
{
	var keys = aShortcut.split('+');
	var keyCode = keys[keys.length-1].replace(/ /g, '_').toUpperCase();

	var key = keyCode;
	keyCode = (keyCode.length == 1 ) ? '' : 'VK_'+keyCode ;
	key = (keyCode != '') ? '' : key;
	return {
		key      : key,
		charCode : (key ? key.charCodeAt(0) : '' ),
		keyCode  : keyCode,
		altKey   : /alt/i.test(aShortcut),
		ctrlKey  : /ctrl|control/i.test(aShortcut),
		metaKey  : /meta/i.test(aShortcut),
		shiftKey : /shift/i.test(aShortcut),
		string   : aShortcut,
		modified : false
	};
}

var tuneshortcut,tsciishortcut,englishshortcut,ascshortcut,tabshortcut,tamshortcut;
var thanthishortcut,manishortcut,selectlist;

function adhiyan_setHotKeyVals()
{
	tamshortcut = document.getElementById('tamshortcut');
	tamshortcut.keyData = adhiyan_parseShortcut(tamshortcut.value);
	tabshortcut = document.getElementById('tabshortcut');
	tabshortcut.keyData = adhiyan_parseShortcut(tabshortcut.value);
	ascshortcut = document.getElementById('ascshortcut');
	ascshortcut.keyData = adhiyan_parseShortcut(ascshortcut.value);
	tuneshortcut = document.getElementById('tuneshortcut');
	tuneshortcut.keyData = adhiyan_parseShortcut(tuneshortcut.value);
	tsciishortcut = document.getElementById('tsciishortcut');
	tsciishortcut.keyData = adhiyan_parseShortcut(tsciishortcut.value);
	englishshortcut = document.getElementById('englishshortcut');
	englishshortcut.keyData = adhiyan_parseShortcut(englishshortcut.value);
	thanthishortcut = document.getElementById('thanthishortcut');
	thanthishortcut.keyData = adhiyan_parseShortcut(thanthishortcut.value);
	manishortcut = document.getElementById('manishortcut');
	manishortcut.keyData = adhiyan_parseShortcut(manishortcut.value);
	selectlist = document.getElementById('selectlist');
	selectlist.setAttribute("adhiyan.attribute.modified","no");
}

function adhiyan_HandleEnterKey(evt)
{
	if(evt.which == 13)
	{
		evt.preventDefault();
		evt.stopPropagation();
		adhiyan_addURL(selectlist);
	}
	else
		return true;
}